<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
      integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N"
      crossorigin="anonymous"
    />
    <style>
      body {
        background: linear-gradient(142deg, #517879 1.09%, #1e3e57 100%);
      }
      .row {
        height: 90vh;
      }
      .col-lg-5 {
        background: linear-gradient(142deg, #517879 1.09%, #1e3e57 100%);
        display: flex;
        flex-direction: column;
        justify-content: center;
      }
      .col-lg-7 {
        background-color: white;
      }
      form {
        margin-left: 15px;
      }
      .content {
        width: 300px;
        flex-shrink: 0;
        color: #fff;
        font-size: 40px;
        font-family: Space Grotesk;
        font-style: normal;
        font-weight: 700;
        line-height: 55px;
        margin-left: 110px;
        margin-bottom: 10px;
      }
      #form-regis {
        margin-top: 175px;
        margin-left: 120px;
      }
      .recom {
        margin-left: 80px;
      }
      .form-control {
        width: 75%;
      }
      .btn.btn-primary {
        background-color: #1e3e57;
        font-size: 20px;
        font-family: Open Sans;
        font-style: normal;
        font-weight: 700;
        line-height: normal;
        width: 75%;
        margin-top: 45px;
        margin-bottom: 80px;
      }
      .person {
        margin-left: 110px;
        color: #fff;
      }
      .tieude {
        margin-bottom: 60px;
        color: #000;
        font-size: 24px;
        font-family: Space Grotesk;
        font-style: normal;
        font-weight: 700;
        line-height: 36px;
      }
    </style>
  </head>
  <body>
    <div class="container mt-5">
      <div class="row">
        <div class="col-lg-7">
          <form id="form-regis">
            <div class="tieude">Let’s get you started</div>
            <div class="form-group">
              <label for="exampleInputEmail1">Full Name</label>
              <input
                type="text"
                class="form-control"
                id="fullname"
                aria-describedby="emailHelp"
              />
            </div>
            <div class="form-group">
              <label for="email">Email</label>
              <input type="email" class="form-control" id="email" />
            </div>
            <div class="form-group">
              <label for="createPassword">Password</label>
              <input type="password" class="form-control" id="createPassword" />
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
            <div class="recom">
              Already have an account?&nbsp;<a
                href="link-to-login"
                class="d-inline text-nowrap"
                >Login</a
              >.
            </div>
          </form>
        </div>
        <div class="col-lg-5">
          <div class="content">“Creativity is intelligence having fun”</div>
          <div class="person">- Albert Einstein</div>
        </div>
      </div>
    </div>
    <script>
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_STATUS_CREATED = 201;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
      const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";

      
      var gInputForm = document.getElementById("form-regis");
      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      gInputForm.addEventListener("submit", function (e) {
        //loai bo cac su kien mac dinh tren form
        e.preventDefault();

        //xu ly su kien login
        register();
      });
      function register() {
        // Step 0: Declare an object to collect data
        var vRegisterData = {
          fullname: "",
          email: "",
          password: "",
        };

        // Step 1: Collect data
        getRegisData(vRegisterData);

        // Step 2: Validate data
        var vValid = validateRegisData(vRegisterData);

        if (vValid) {
          // Step 3: Connect to the API
          const vRegisObj = new URLSearchParams(vRegisterData);
          var vXmlHttpRegis = new XMLHttpRequest();
          callRegisApi(vXmlHttpRegis, vRegisObj);

          vXmlHttpRegis.onreadystatechange = function () {
            if (
              this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
              this.status == gREQUEST_STATUS_CREATED
            ) {
              // Step 4: Display the result
              displayResult(vXmlHttpRegis.responseText);
            }
          };
        }
      }

      //ham thu thap du lieu
      function getRegisData(paramRegisData) {
        var vNameEle = document.getElementById("fullname");
        var vEmailEle = document.getElementById("email");
        var vPasswordEle = document.getElementById("createPassword");

        paramRegisData.fullname = vNameEle.value; // Updated property name from 'fullname' to 'name'
        paramRegisData.email = vEmailEle.value;
        paramRegisData.password = vPasswordEle.value;
      }

      //ham kiem tra du lieu
      function validateRegisData(paramRegisData) {
        //kiem tra dinh dạng email
        if (paramRegisData.fullname == "") {
          alert("Tên không để trống");
          return false;
        }
        if (!validateEmail(paramRegisData.email)) {
          alert("Email không đúng định dạng");
          return false;
        }

        //kiem tra dinh dang password
        if (paramRegisData.password.length < 5) {
          alert("Độ dài mật khẩu phải từ 5 ký tự");
          return false;
        }
        return true;
      }

      function validateEmail(paramEmail) {
        var vRegexEmail = /^[a-zA-Z0-9_]+@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*$/;
        if (paramEmail.match(vRegexEmail)) {
          return true;
        } else {
          return false;
        }
      }

      function callRegisApi(paramXmlHttpRegis, paramRegisObj) {
        paramXmlHttpRegis.open("POST", gBASE_URL, true);
        paramXmlHttpRegis.setRequestHeader(
          "Content-Type",
          "application/json"
        );
        paramXmlHttpRegis.send(JSON.stringify(paramRegisObj));

      }

      //Hàm hiển thị kết quả
      function displayResult(paramRegisData) {
        console.log(paramRegisData);
      }
    </script>
  </body>
</html>
